# coding: latin-1

def get_instanzdienst_cls(name, display_name, description, port, instance_home):
    import win32serviceutil
    import win32service
    import win32event
    class Instanzdienst(win32serviceutil.ServiceFramework):
        # Diese Variablen müssen von der Komponente gesetzt werden.
        _svc_name_ = name
        _svc_display_name_ = display_name
        _svc_description_ = description
        _instance_port_ = port
        _instance_home_ = instance_home
        def __init__(self, args):
            assert self._instance_port and self._instance_home
            win32serviceutil.ServiceFramework.__init__(self, args)

        def SvcStop(self):
            self.ReportServiceStatus(win32service.SERVICE_STOP_PENDING)
            self._stop(self._instance_port_)

        def SvcDoRun(self):
            self._start(self._instance_home_)

        def _start(self, instance_home):
            import os
            os.chdir(instance_home)
            import init
            import ebkus.ebs
            from ebkus.bobo.pcgi_publisher import main
            main('ebkus.ebs')

        def _stop(self, port):
            import sys, socket, os, traceback
            # Wir sind im selben Prozess, localhost sollte immer gehen
            host = 'localhost'
            tosend = 'XX6859236XXquit'
            try:
                s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                s.connect((host, port))
                s.send(tosend)
                s.shutdown(1)
                s.close()
            except:
                #traceback.print_exc()
                #print 'Something went wrong'
                sys.exit(1)
    return Instanzdienst
